
# Version options
%define kernel_base_version 2.4.22
%define kernel_extra_version	%nil
# Numeric extra version scheme developed by Alexander Bokovoy:
# 0.0.X -- preX
# 0.X.0 -- rcX
# 1.0.0 -- release
%define kernel_extra_version_numeric 1.0.0
%define krelease alt36

%define base_flavour	std
%define subflavour	up

%define flavour		%base_flavour-%subflavour

# Build options
# You can change compiler by editing and uncommenting this line:
#define kgcc gcc-3.2

# Enable/disable SGML docs formatting
%def_enable docs

# Fixes:
%add_patch_list kernel-fix-build

%add_patch_list kernel-fix-security-owl
%add_patch_list kernel-fix-security

%add_patch_list kernel-fix-net
%add_patch_list kernel-fix-core 
%add_patch_list kernel-fix-fs
%add_patch_list kernel-fix-lvm

%add_patch_list kernel-fix-drivers-ide
%add_patch_list kernel-fix-drivers-net
%add_patch_list kernel-fix-drivers-pci
%add_patch_list kernel-fix-drivers-scsi 
%add_patch_list kernel-fix-drivers-sound 
%add_patch_list kernel-fix-drivers-usb
%add_patch_list kernel-fix-drivers-cdrom
%add_patch_list kernel-fix-drivers-char
%add_patch_list kernel-fix-drivers-md
%add_patch_list kernel-fix-drivers-mtd
%add_patch_list kernel-fix-drivers-video
%add_patch_list kernel-fix-drivers-ieee1394
%add_patch_list kernel-fix-drivers-atm
%add_patch_list kernel-fix-drivers-pnp
%add_patch_list kernel-fix-drivers-block


##################
%add_patch_list kernel-feat-fs-xfs
%add_patch_list kernel-feat-acpi
%add_patch_list kernel-feat-cpufreq
#add_patch_list kernel-feat-core-O1sched
#add_patch_list kernel-feat-addon
#add_patch_list kernel-feat-bttv
%add_patch_list kernel-feat-i2c kernel-feat-fs-ntfs
%add_patch_list kernel-feat-kconfig
%add_patch_list kernel-feat-crypto
%add_patch_list kernel-feat-drivers-usb
%add_patch_list kernel-feat-drivers-block-enbd
#add_patch_list kernel-feat-drivers-pktcdvd
%add_patch_list kernel-feat-drivers-video-splash
%add_patch_list kernel-feat-net-ppp-mppe
%add_patch_list kernel-feat-net-ipsec
%add_patch_list kernel-feat-drivers-media-v4l2
#add_patch_list kernel-feat-saa7134
%add_patch_list	kernel-feat-drivers-net-sk98lin
%add_patch_list	kernel-feat-drivers-sound-emu10k1
%add_patch_list kernel-feat-drivers-libata
%add_patch_list kernel-feat-drivers-net-pcnet32-old

## Don't edit below this line ##################################

%define	kversion %kernel_base_version

%{?__ccache_cc: %define _disable_ccache 1}

%if_enabled ccache
%define kcc "ccache %kgcc"
%else
%define kcc "%kgcc"
%endif

%ifdef use_ccache
%define kcc "ccache %kgcc"
%else
%define kcc "%kgcc"
%endif

Name: kernel-image-%flavour
Version: %kversion
Release: %krelease

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
URL: http://www.kernel.org/
Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>

Source1: config-%kversion-%flavour
Source2: rhkmvtag.c
%define rhkmvtag %SOURCE2

Source3: kernel-headers-Makefile.patch

ExclusiveOS: Linux

BuildRequires: coreutils libdb4-devel perl flex dev86
BuildRequires: rpm >= 4.0.2-75
BuildRequires: kernel-source-%kernel_base_version = %kernel_extra_version_numeric
BuildRequires: kernel-build-tools
BuildRequires: %get_patch_list
BuildRequires: %(echo %kgcc | sed -e "s/-//")
BuildRequires: kernel-fix-core >= 2003.06.11

%if_enabled docs
BuildRequires: docbook-utils transfig ghostscript
%endif

%if_enabled ccache
BuildRequires: ccache
%endif

%ifdef use_ccache
BuildRequires: ccache
%endif

Requires: bootloader-utils >= 0.1-alt7, modutils, mkinitrd >= 1:2.8.6-alt2
Provides: kernel = %kversion
Provides: kernel24 = %kversion

Prereq:		coreutils
Prereq:		modutils >= 2.4.17
Prereq:		bootloader-utils >= 0.1-alt7
Prereq:		mkinitrd >= 1:2.8.6-alt2
Obsoletes:	kernel-modules, kernel-modules-i2c-%flavour
ExclusiveArch:	%ix86


%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.
Patches included:%format_patch_list

%package -n kernel-headers-%flavour
Summary: Header files for the Linux kernel
Group: System/Kernel and hardware
Requires: kernel-headers-common >= 1.1
Obsoletes: kernel-headers-i2c-%flavour
Provides: kernel-headers-%base_flavour = %version-%release
Provides: kernel-headers = %version
Provides: kernel24-headers = %version

%description -n kernel-headers-%flavour
These are the C header files for the Linux kernel, which define
structures and constants that are needed when building most standard
programs under Linux, as well as to rebuild the kernel.
Patches included:%format_patch_list

%package -n kernel-headers-modules-%flavour
Summary: SCSI header files for the Linux kernel
Group: System/Kernel and hardware
Requires: kernel-headers-%flavour = %version-%release

%description -n kernel-headers-modules-%flavour
These are the C header files for the Linux kernel scsi subsystem, which define
structures and constants that are needed when building only scsi-related 
kernel modules. Don't use it for any purposes except building a kernel modules.

%package -n kernel-doc-%base_flavour
Summary: Linux kernel %kversion documentation
Group: System/Kernel and hardware

%description -n kernel-doc-%base_flavour
This package contains documentation files for ALT Linux kernel packages:
 * kernel-image-%base_flavour-up-%kversion-%krelease
 * kernel-image-%base_flavour-smp-%kversion-%krelease

%prep

%setup -cT -n kernel-image-%flavour-%kversion-%krelease

%__rm -rf kernel-source-%kernel_base_version

%__tar -jxf %kernel_src/kernel-source-%kernel_base_version.tar.bz2

%setup -D -T -n kernel-image-%flavour-%kversion-%krelease/kernel-source-%kernel_base_version

echo "patches = %_patch_list"

%apply_patches 2.4

%__subst 's/EXTRAVERSION =.*/EXTRAVERSION = %kernel_extra_version-%flavour-%krelease/g' Makefile
%__subst 's/CC.*$(CROSS_COMPILE)gcc/CC		= %kgcc/g' Makefile


%build

KERNEL_BUILD_DIR=`pwd`


KernelVer=%kversion-%flavour-%krelease

echo "Building Kernel $KernelVer"

:> arch/%base_arch/defconfig

%__cat %SOURCE1 >> arch/%base_arch/defconfig

%make_build mrproper CC=%kcc

%make_build oldconfig CC=%kcc

### It's a hack, but a useful hack:

cmp -s .config %SOURCE1 || %__cp -vf .config %SOURCE1

%make_build dep clean CC=%kcc

%make_build include/linux/version.h CC=%kcc

%make_build bzImage CC=%kcc

%make_build modules CC=%kcc YACC="bison -y"

echo "Kernel built $KernelVer"

%if_enabled docs
# psdocs, pdfdocs don't work yet
%make_build htmldocs
%endif

%install

KernelVer=%kversion-%flavour-%krelease


%__mkdir -p $RPM_BUILD_ROOT/boot
%__install System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
%__cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
%__cp .config $RPM_BUILD_ROOT/boot/config-$KernelVer

%__make modules_install \
    INSTALL_MOD_PATH=$RPM_BUILD_ROOT \
    KERNELRELEASE=$KernelVer

%__cc -o rhkmvtag %rhkmvtag init/version.o
./rhkmvtag >$RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag ||:
%__rm -f rhkmvtag

%__install -d $RPM_BUILD_ROOT%_prefix/include/linux-%version-%flavour/include

pushd include
%__cp -a . $RPM_BUILD_ROOT%_prefix/include/linux-%version-%flavour/include
popd

# drivers-headers install
%__install -d $RPM_BUILD_ROOT%_prefix/src/linux-%version-%flavour/drivers/scsi
%__cp -a ./drivers/scsi/{{constants,sd,scsi,hosts,scsi_obsolete}.h,scsi_module.c} \
	$RPM_BUILD_ROOT%_prefix/src/linux-%version-%flavour/drivers/scsi/

#%__install -d $RPM_BUILD_ROOT%_prefix/src/linux-%version-%flavour/drivers/media/video
#%__cp -a ./drivers/addon/bttv/{{id,bttv,bttvp,audiochip,i2c-compat,tuner,bt848}.h} \
#	$RPM_BUILD_ROOT%_prefix/src/linux-%version-%flavour/drivers/media/video

%__install -d %buildroot%_prefix/src/linux-%version-%flavour/arch/%base_arch
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/scripts
%__cp -a ./{Makefile,Rules.make} \
	%buildroot%_prefix/src/linux-%version-%flavour/
%__cp -a ./arch/%base_arch/Makefile \
	%buildroot%_prefix/src/linux-%version-%flavour/arch/%base_arch/
%__cp -a ./scripts/pathdown.sh \
	%buildroot%_prefix/src/linux-%version-%flavour/scripts/

pushd %buildroot%_prefix/src/linux-%version-%flavour
ln -sf ../../include/linux-%version-%flavour/include include
patch Makefile < %SOURCE3
popd

%__cp -a .config $RPM_BUILD_ROOT%_prefix/src/linux-%version-%flavour/.config
pushd $RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
ln -sf %_prefix/include/linux-%version-%flavour/ \
    $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
popd

# remove asm-* include files for other architectures
pushd $RPM_BUILD_ROOT%_prefix/include/linux-%version-%flavour/include
for dir in asm-*; do
	[ "$dir" = "asm-generic" ] && continue
	[ "$dir" = "asm-%base_arch" ] && continue
	%__rm -rf -- "$dir"
done
popd

# install documentation
%if_enabled docs
%__install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/
%__cp -a Documentation/* %buildroot%_docdir/kernel-doc-%base_flavour-%version/
%__install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/
%__cp -a drivers/scsi/README* \
	%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/
for dir in aacraid aic7xxx aic7xxx_old; do
	%__install -d \
		%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/$dir/
	%__cp -a drivers/scsi/$dir/README* \
		%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/$dir/
done
%__install -d \
	%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/sym53c8xx_2
%__cp -a drivers/scsi/sym53c8xx_2/*.txt \
	%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/sym53c8xx_2
%endif # if_enabled docs

%post
cd /boot
if [ -x /sbin/installkernel ];then
    /sbin/installkernel -a -c %kversion-%flavour-%krelease
fi

ln -snf vmlinuz-%kversion-%flavour-%krelease /boot/vmlinuz-%subflavour
ln -snf initrd-%kversion-%flavour-%krelease.img /boot/initrd-%subflavour.img

# later - fix please bootloader-utils package
ln -snf vmlinuz-%kversion-%flavour-%krelease /boot/vmlinuz
ln -snf initrd-%kversion-%flavour-%krelease.img /boot/initrd.img


%preun
/sbin/modprobe loop 2> /dev/null > /dev/null

REMOVE=
if [ -f /etc/sysconfig/system ];then
		source /etc/sysconfig/system
		[[ "$CLASS" = "beginner" ]] && REMOVE=yes
fi
if [ -f /etc/sysconfig/installkernel ];then
		source /etc/sysconfig/installkernel
		[[ "$AUTOREMOVE" = [Yy][Ee][Ss] ]] && REMOVE=yes
		[[ "$AUTOREMOVE" = [Nn][Oo] ]] && REMOVE=
fi

BUILD=/lib/modules/%kversion-%flavour-%krelease/build 

/sbin/installkernel -a -R -c %kversion-%flavour-%krelease

%postun
rm -f /boot/initrd-%kversion-%flavour-%krelease.img

%files
%defattr(644,root,root,755)
/boot/vmlinuz-%version-%flavour-%krelease
/boot/System.map-%version-%flavour-%krelease
/boot/config-%version-%flavour-%krelease
/lib/modules/%version-%flavour-%krelease
%exclude /lib/modules/%version-%flavour-%krelease/build

%files -n kernel-headers-%flavour
%defattr(644,root,root,755)
%dir %_prefix/include/linux-%version-%flavour
%_prefix/include/linux-%version-%flavour/include
/lib/modules/%version-%flavour-%krelease/build

%files -n kernel-headers-modules-%flavour
%defattr(644,root,root,755)
%_prefix/src/linux-%version-%flavour

%if_enabled docs
%files -n kernel-doc-%base_flavour
%defattr(644,root,root,755)
%doc %_docdir/kernel-doc-%base_flavour-%version
%endif

%changelog
* Wed May 11 2005 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt36
- Updated kernel-fix-security:
  + fix ELF core dump issue (CAN-2005-1263)

* Mon Mar 28 2005 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt35
- Updated kernel-fix-security:
  + fixed isofs corrupted filesystem handling (CAN-2005-0815)
  + fixed bluetooth range checking bug (CAN-2005-0750)
  + fixed ext2 information leak (CAN-2005-0400)
  + fixed binfmt_elf DoS (CAN-2005-0749)

* Wed Mar 16 2005 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt34
- Updated kernel-fix-security:
  + fix ppp_async issue (CAN-2005-0384)

* Fri Jan 07 2005 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt33
- Updated kernel-fix-security:
  + check for zero program header on load_elf_interp()
  + fix uselib() issue (CAN-2004-1235)
  + fix expand_stack issue (CAN-2005-0001)
  + fix integer signedness issues in moxa and random drivers

* Thu Dec 23 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt32
- Updated kernel-fix-security:
  + fix binfmt_elf issue (CAN-2004-1234)

* Wed Dec 15 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt31
- Updated kernel-fix-security:
  + fix CMSG validation (CAN-2004-1016)
  + fix IGMP issues
  + fix IP options leak

* Sat Nov 27 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt30
- Updated kernel-fix-security:
  + fix bugs in ppos races fix
  + fix smbfs issues (CAN-2004-0883, CAN-2004-0949)
  + fix binfmt_elf vulnerabilities (isec-0017)
  + fix tty locking bugs
  + fix binfmt_aout vulnerabilities
  + fix AF_UNIX dgram read locking
- Updated kernel-fix-drivers-usb:
  + fix usbserial locking bugs which could cause oopses and panics
  + avoid loss of written data if the usbserial device was busy
- Updated kernel-feat-drivers-video-splash:
  + updated patch for compatibility with new kernel-fix-security

* Mon Jul 26 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt29
- Updated kernel-fix-security, kernel-fix-drivers-ieee1394, kernel-feat-i2c:
  + fix ppos races (CAN-2004-0415)
  + fix more flaws found by the Sparse source code checker (CAN-2004-0685)

* Mon Jun 28 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt28
- Updated kernel-fix-drivers-char:
  + added minimal AGP 3.x support for SiS 648FX chipset to agpgart (fixes hang
    at X startup with the radeon driver)
- Updated kernel-fix-security:
  + fix DAC checks in *chown

* Fri Jun 25 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt26
- bump release

* Fri Jun 25 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt25
- Updated kernel-fix-drivers-char:
  + added lots of new Via host bridge PCI IDs to agpgart
- Updated kernel-fix-security-owl:
  + add kernel.shm_destroy_unused sysctl to control CONFIG_HARDEN_SHM state at
    runtime (so it can be turned off to work around problems in some badly
    written programs).

* Sun Jun 20 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt24
- Updated kernel-fix-security, kernel-feat-acpi:
  + fix flaws found by the Sparse source code checker (CAN-2004-0495)
- Updated kernel-fix-security-owl:
  + fix MAGIC_RT_SIGRETURN handling
  + fix GCC trampoline call emulation for addressing modes with no index in SIB
    (e.g. call *0x24(%esp,1)) and absolute base in SIB (e.g. call
    *static_var(%eax,4))

* Mon Jun 14 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt23
- Updated kernel-fix-security:
  + fix possible fork() memory leak (CAN-2004-0427)
  + fix potential access to free memory in /proc handling
  + fix FPU exception handling DoS
- Updated kernel-fix-drivers-net:
  + fix information leak in e1000 (CAN-2004-0535)

* Tue Apr 27 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt22
- Updated kernel-fix-drivers-net:
  + update e1000 driver from 5.1.13-k1 to 5.2.20-k1 (bugfixes, new hardware
    support)

* Sun Apr 25 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt21
- Updated kernel-feat-cpufreq:
  + fix for (un)signed int wrap in proc_handler (CAN-2004-0228)

* Thu Apr 22 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt20
- Updated kernel-fix-security:
  + fixed MCAST_MSFILTER error handling to return -EINVAL correctly
- Updated kernel-fix-drivers-char:
  + workaroung for SiS 648 and 746 AGP problem (need to wait for some time
    after switching AGP modes)

* Tue Apr 20 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt19
- Updated kernel-fix-security:
  + fixed:
    + MSFILTER issue (isec-0015)

* Tue Apr 13 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt18
- Updated kernel-fix-security:
  + fixed:
    + isofs issue (CAN-2004-0109)
    + jfs issue (CAN-2004-0181)
    + ext3 issue (CAN-2004-0177)
    + xfs issue (CAN-2004-0133)
    + ncpfs issue (CAN-2004-0010)

* Wed Feb 04 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt17
- Updated kernel-fix-drivers-net:
  + tulip: add PCI IDs (3com 3CSOHO100B-TX, etc...)
- Updated kernel-fix-drivers-usb:
  + avoid usb-storage deadlocks by using GFP_NOIO for USB memory allocations
  + add support for new usb-storage devices
  + fix usb-storage failure handling
  + EHCI driver fixes for high bandwidth iso transfers
- Updated kernel-fix-fs:
  + avoid buffer overrun in mount options parsing
- Updated kernel-feat-acpi:
  + Updated ACPI patch (26-Jan-2004, ACPICA 20040116)
- Updated kernel-feat-drivers-libata:
  + new version (2.4.25-pre4-libata1):
    - fake BIOS geometry for partition tables
    - sata_promise: better support for Promise SX4 (initialize DIMM, fix Host
      DMA)
    - sata_svw: probe all 4 ports, limit UDMA modes
- Updated kernel-feat-drivers-media-v4l2 (new upstream release).
- Updated kernel-feat-drivers-net-sk98lin (6.21 release).
- Updated kernel-feat-fs-xfs (new upstream release).
- Updated kernel-feat-i2c (2.8.3 release).
- Removed kernel-fix-drivers-media (not needed for new
  kernel-feat-drivers-media-v4l2).
- Updated kernel config for new XFS.
- Spec file cleanup:
  + general cleanup
  + removed EXTRAVERSION duplication
  + modified kernel-headers build to avoid dependencies on patches (some
    patches add include files)
  + added %%subflavour macro for up/smp
  + resync up and smp subflavours (now the docs generation parts are in both
    subflavours, but enabled only in -up)

* Sun Jan 25 2004 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt16
- Updated kernel-fix-drivers-char:
  + AGP support for ATI IGP 345M
- Updated kernel-fix-drivers-ide:
  + fix pdcraid detection
- Updated kernel-fix-fs:
  + fix tmpfs seekdir oops
  + fix ext3 quota deadlock
  + make tmpfs readdir update atime
  + fix hfs oops with non-512 byte sectors (CD-ROM)
  - reverted inode_hash race fix (causes deadlocks on SMP)
- Updated kernel-fix-security:
  + backported more mmap fixes from 2.4.23-ow2
  + fixed CAN-2003-0984
- Fixed dependencies:
  + added proper Prereq to kernel-image
  + added versions to Provides in kernel-headers

* Wed Dec 31 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt15
- Updated kernel-fix-core:
  + removed bogus panic calls from the MP table parsing code
- Updated kernel-fix-security:
  + fixed CAN-2003-0985

* Thu Dec 25 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt14
- Updated kernel-feat-acpi:
  + Updated ACPI patch (18-Dec-2003, ACPICA 20031203)
  + Fixed SMP boot (broken by the previous ACPI patch)
  + Blacklisted Supermicro 370DL3/370DLE (PCI bus lost without pci=noacpi).

* Tue Dec 16 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt13
- Added kernel-fix-drivers-block:
  + fix losetup uninterruptible sleep if kernel_thread fails
- Updated kernel-fix-core:
  + do not allow mmap with PROT_EXEC if the filesystem was mounted with
    'noexec'
- Updated kernel-fix-drivers-char:
  + added NetMos parallel/serial PCI cards support
- Updated kernel-fix-drivers-net:
  + pppoe: do not leak SKB if sock_queue_rcv_skb() fails
  + fixed duplex selection for DL10019 cards in pcnet_cs driver
  + added Prism 3 ID to orinoco_pci
- Updated kernel-fix-drivers-scsi:
  + 3ware driver update: Fix tw_ioctl() to handle all non-data ATA passthru
    cmds for 'smartmontools' support
- Updated kernel-fix-drivers-sound:
  + forte sound driver update (fixes many bugs, including calling BUG() on
    failed memory allocation instead of returning -ENOMEM)
- Updated kernel-fix-drivers-usb:
  + ftdi_sio: add support for Protego devices
  + scanner: version 0.4.16: new device ids
  + pegasus: driver update (new device ids, fixed flags for some devices)
  + usb-storage: new device support:
    * Pentax Optio S4
    * Fujifilm EX-20
    * Kyocera S5 camera
    * Minolta DiMAGE 7/7i//7Hi
    * Sony Memory Stick Reader MSAC-US1
    * freecom dvd-rw fx-50 usb-ide
    * CD-509 USB to IDE
    * Mitsumi USB FDD
    * Minolta Dimage S414
    * Medion 6047 Digital Camera
    * Datafab USB to CF + SM Combo (LC1)
  + pl2303: new device ids
  + io_edgeport: fixed error handling, fixed alignment issues
  + printer: Backport 2.6=>2.4 (fixed buffer allocation and possible races)
  + mct_u232: allow MCT-U232 to work with devices which do not assert CTS
  + visor: add support for Sony UX50 device
- Updated kernel-fix-drivers-video:
  + limit vesafb video memory size to 16M to avoid running out of kernel
    address space (it is possible to override this limit with the 'vram'
    parameter if needed).
- Updated kernel-fix-fs:
  + remove broken file lock accounting
  + fix end_buffer_io_kiobuf() locking
  + fix potential fsync() race condition
- Updated kernel-fix-net:
  + sock_queue_rcv_skb(): do not deref skb->len after it is queued to the
    socket.
  + econet: do not leak SKBs if ec_queue_packet() fails
- Updated kernel-feat-acpi:
  + Updated ACPI patch (11-Dec-2003, ACPICA 20031203)
- Updated kernel-feat-cpufreq:
  + longhaul: Ezra-T support added, rounding fixes
  + speedstep-centrino: Ultra Low Voltage Intel Pentium M processor 1000MHz
    support added
- Updated kernel-feat-drivers-libata:
  + fix for Promise SX4 (only one Host DMA engine, not one per port)
  + fix oops on libata unload
- Updated kernel-feat-i2c:
  + 2.8.2 release

* Sat Nov 29 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt12
- Updated kernel-fix-security:
  + fixed CAN-2003-0001, CAN-2003-0461, CAN-2003-0961

* Fri Nov 28 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt11
- Updated kernel-fix-fs:
  + fixed iso9660 mount options handling
- Added kernel-fix-security.
- Updated kernel-feat-acpi:
  + new ACPI patch (ACPI hotplug fix, pci=noacpi fix)
- Updated kernel-feat-cpufreq:
  + speedstep-smi driver fixes
- Updated kernel-feat-drivers-libata:
  + updated libata patch to 2.4.23-rc3-libata1:
    - fixed a bug which may cause some devices to "not be talked to" at probe
      time (fixed flush of Device Control register to device)
    - ServerWorks-specific tweaks
  + added Intel Software RAID (ICH5R) support (iswraid module)
- Modified security configuration:
  + Non-executable user stack area enabled (with GCC trampolines
    autodetection): CONFIG_HARDEN_STACK=y, CONFIG_HARDEN_STACK_SMART=y
  + Restricted /proc enabled: CONFIG_HARDEN_PROC=y

* Wed Nov 19 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt10
- Fixed file lists for kernel-headers-%%flavour:
  + added acpi/, crypto/, freeswan.h, freeswan/, pfkey.h, pfkeyv2.h, zlib/
- Fixed kernel-headers-modules-%%flavour dependencies.
- Modified configuration:
  - adma100, sc1200, siimage drivers are now built into the kernel (building
    IDE controller drivers as modules does not work unless the whole IDE
    subsystem is in modules too)
  - tvmixer module is not built (now it is in kernel-modules-v4l-%%flavour)
- Added kernel-fix-drivers-pnp:
  + fixed problems with detection of some ISA PnP cards
- Updated kernel-fix-drivers-net:
  + fixed multicast list handling in the tulip driver
- Updated kernel-fix-drivers-scsi:
  + sg driver bugfix: do not accept negative sizes in SG_SET_RESERVED_SIZE
- Updates kernel-fix-fs:
  + fixed quota stats accounting bug
  + fixed races on inode deletion (could cause oops with NFS)
- Updated kernel-feat-acpi:
  + new ACPI patch (IRQ assignment fixes, poweroff fix)
- Updated kernel-feat-drivers-libata:
  + new upstream version (Promise driver bugfixes)
  + added support for Promise FastTrak 376

* Sat Nov 15 2003 Albert R. Valiev <darkstar@altlinux.ru> 2.4.22-alt9
- Added kernel-feat-driver-net-pcnet32-old patch 
- fix for vmware network card driver

* Sun Nov 09 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt8
- Updated kernel-feat-acpi (ACPI updates and fixes, Alt-SysRq poweroff fix).
- Updated kernel-feat-drivers-libata (new version, Promise SATA driver
  significantly enhanced).
- Updated kernel-fix-drivers-scsi (updated ServeRAID and MegaRAID drivers, SCSI
  blacklist updates).
- Added kernel-fix-drivers-cdrom (bugfixes).
- Updated kernel-fix-core, kernel-fix-drivers-char, kernel-fix-drivers-ide,
  kernel-fix-drivers-ieee1394, kernel-fix-drivers-net, kernel-fix-drivers-pci,
  kernel-fix-drivers-sound, kernel-fix-drivers-usb, kernel-fix-fs,
  kernel-fix-lvm, kernel-fix-net (lots of bugfixes).
- Relaxed BuildRequires (libdb4.0-devel -> libdb4-devel) (#2826).

* Sun Oct 19 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt7
- Updated kernel-feat-acpi (important bugfixes; enabled DMI info dump; moved
  ACPI BIOS date cutoff from 2001 to 2000).
- Added kernel-fix-lvm (makes LVM snapshots work with journaling FS).
- Added documentation subpackage (common for std-up and std-smp flavours).
- Added kernel-feat-libata (Serial ATA drivers). Supported devices: Intel ICH5,
  Promise FastTrak S150 TX2plus/TX4/SX4, Broadcom (Apple K2) SATA, VIA SATA.
  Silicon Image SATA support not enabled (does not work yet).
- Updated kernel-feat-i2c (2.8.1 release).

* Tue Oct 07 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt6
- updated kernel-feat-net-ppp-mppe (this version should really work)
- updated kernel-feat-crypto:
  - back to old cryptoapi from kerneli.org
- moved .config to kernel-headers-modules
- added toplevel Makefile and Rules.make to kernel-headers-modules (needed for
  compilation of some external modules)
- added kernel-feat-cpufreq (frequency/voltage scaling support)
- removed kernel-feat-bttv, kernel-feat-saa7134 (now in kernel-modules-v4l)
- removed kernel-feat-addon (no longer used)
- updated kernel-feat-acpi (more fixes)
- turned off OV511 USB camera driver (now in kernel-modules-v4l)

* Mon Sep 29 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt5
- updated kernel-fix-net:
  - hidden IGMPv3 definitions in <linux/in.h> from userspace (workaround for
    #3053)
- updated kernel-fix-drivers-usb, kernel-feat-drivers-usb:
  - lots of bugfixes and new device IDs
- updated kernel-fix-drivers-char:
  - added AGP support for Intel 875 (integrated video not supported)
- fixed kernel-headers-modules building:
  - install updated bttv headers instead of obsolete ones

* Wed Sep 24 2003 Sergey Vlasov <vsu@altlinux.ru> 2.4.22-alt4
- added kernel-feat-acpi:
    + ACPI update 20030916-2.4.22 (should fix some problems with nForce)
    + DSDT override from initrd
    + blacklist updates
- added kernel-fix-drivers-mtd, kernel-fix-drivers-sound,
  kernel-fix-drivers-video:
    + missing MODULE_LICENSE fixes
- updated kernel-fix-drivers-char:
    + fixed AGP 3.0 support for Via KT400
    + added AGP support for Intel 7x05, ATI Radeon IGP, Via CLE266
- updated kernel-fix-drivers-pci:
    + enable SMBus controller on ASUS boards
- added kernel-headers-modules-%flavour package (Rider)
- added provides: kernel24-headers (Rider)
- added kernel-feat-drivers-sound-emu10k1 (Rider)
    + update emu10k1 to 0.20a
- added drivers/media/video/ headers to kernel-headers-modules package (Rider)
- disabled 8139cp (PCI ID conflict with 8139too)
- added kernel-fix-drivers-ieee1394, kernel-fix-drivers-atm

* Thu Sep 11 2003 Anton Farygin <rider@altlinux.ru> 2.4.22-alt3
- enabled aic79xx module by default
- updated sk98lin driver for support 3c940 and other (based on sk98)  ethernet cards
- enabled CONFIG_4GB option
- build ATM support for UP kernel

* Tue Sep 09 2003 Anton Farygin <rider@altlinux.ru> 2.4.22-alt2
- fixed bug with build userspace v4l programms

* Tue Sep 02 2003 Rider <rider@altlinux.ru> 2.4.22-alt1
- update to 2.4.22
- removed ACPI patches (mainstream)
- removed O(1)sheduler

* Tue Aug 26 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt14
- played with OWL patch configs. installator should work just fine now.

* Thu Aug 14 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt13
- added Video4Linux Version 2 API patch.
- added kernel-fix-drivers-md.
- added saa7134 driver.

* Wed Aug 13 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt12
- removed percentexclude pcmcia dir.

* Mon Aug 11 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt11
- getting back bttv.

* Mon Aug 11 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt10
- upgraded patches.
- added patches:
  + kernel-fix-drivers-char
  + kernel-fix-drivers-video
- temporary removed patches:
  - kernel-feat-bttv

* Thu Aug 07 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt9
- got back all the pcmcia inkernel drivers, as 3.2.4 are considered as
  experimental.

* Thu Jul 31 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt8
- added kernel-headers to provides of kernel-headers-%{flavour}.
- replaced get_patch_list with format_patch_list.
- rebuilt with new kernel-fix-core with new dcache names patch. start-stop-daemon
  should work now.
- added asm-generic directory to headers.
- don't build pcmcia modules inside the kernel.

* Wed Jul 30 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt7
- removed iscsi patch as rider@ and ab@ suggested.

* Thu Jul 17 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt6
- Added provides kernel24
- ACPI support now included (+ kernel-feat-acpi)
- Fixed OWL security patch configuration, proc is now visible to all in
  std kernels.

* Tue Jul 15 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt5
- new patches:
  + kernel-fix-fs

* Wed Jul 09 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt4
- compiled Promise PDC drivers in kernel (satisfying request by mouse@a.r).

* Mon Jul 07 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt3
- new patches:
  + kernel-fix-drivers
  \ + ide 
    + net
    + pci 
    + scsi
    + usb
    + security-owl
  + kernel-feat
  \ + fs-ntfs
    + i2c
- fixed spec in many places
- changed /etc/apt/apt.cond.d/file filename so that kernel packages with different versions installed at one time
  don't conflict.

* Sat Jun 21 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rel-alt1
- upgraded to rc7
- applied patches:
  + kernel-fix-core
  + kernel-feat-core-O1sched
  + kernel-feat-iscsi 
  + kernel-feat-bttv
  + kernel-feat-fs-xfs
  + kernel-feat-kconfig
  + kernel-feat-addon
  + kernel-feat-crypto
  + kernel-feat-drivers-video-splash
  + kernel-feat-net-ipsec
  \ + ipsec
    + ppp-mppe

* Mon May 26 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rc1-alt3
- compile ext2 filesystem in kernel for installer needs.
- added net-ipsec and video-splash features.

* Thu May 15 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21rc1-alt2
- removed crypto patch because it bugs loop filesystem. ... And added 
  it again, because it doesn't.

* Fri Apr 25 2003 Peter Novodvorsky <nidd@altlinux.com> kernel-policy-rc.2
- rc2 policy release.
